-- MonLogiciel.applescript

--  Created by Alain Le Gallou on 10/12/07.

global notesDataSource -- Data Source référence 
global cancel
global OK

property nomFichierPlist : "com.legallou.MonLogiciel.plist"
property dossierRacine : missing value -- Chemin d'accès à l'application 
property cheminBibliothequePreferenceUtilisateur : missing value -- "iMac:Users:alg:Library:Preferences:"
property nomDuFichierPlistPreferenceUtilisateur : missing value --"iMac:Users:alg:Library:Preferences:com.legallou.MonLogiciel.plist"



on awake from nib theObject --------------------------------------
	
	if the name of theObject is "Main" then
		log "Main"
		Notes_Init_Data() -- pour debugging et initialisation du tutoriel
	end if
	
end awake from nib --------------------------------------




on clicked theObject --------------------------------------
	
	
	-- Exemple pour démonstration du click dans un tableau, à ne pas garder par la suite
	
	if (the name of theObject is "notesTableView") then
		
		set notesTablePointeur to table view "notesTableView" of scroll view "notesScrollView" of window "Main"
		log notesTablePointeur
		
		set selectedDataRows to selected data rows of notesTablePointeur
		log selectedDataRows
		-- Le résultat est "data row id 9 of data source id 5"
		
		
		if (count of selectedDataRows) > 0 then -- Zéro si click hors du tableau
			
			set uneLigne to item 1 of selectedDataRows
			-- Le résultat est "data row id 19 of data source id 12"
			
			set laLigne to content of uneLigne
			log laLigne
			--> {|Col5|:"c5", |Col6|:"c6", |Date|:date "mercredi 6 décembre 2006 0:00:00", |Prix|:29, |Description|:"FTP", |Name|:"Transmit"}
			
			
			set leNom to |Name| of laLigne
			set lePrix to |Prix| of laLigne
			
			display dialog leNom & " coûte " & lePrix & " €"
		end if
	end if
end clicked --------------------------------------






on column clicked theObject table column tableColumn -------------------------
	--TRI d'une colonne avec inversion de ascending descending ---
	-- Tri de celle qui a été cliquée - programme standard Apple
	-- Voir AppleScript Studio exemple dans "table sort"
	
	-- Obtention de la data source du tableau
	set theDataSource to data source of theObject
	
	-- Obtention de l'identifiant de la colonne cliquée
	set theColumnIdentifier to identifier of tableColumn
	
	-- Quelle est la colonne de tri actuelle dans la data source
	set theSortColumn to sort column of theDataSource
	
	-- Si la colonne de tri n'est pas celle cliquée, inverser les colonnes
	if (name of theSortColumn) is not equal to theColumnIdentifier then
		set the sort column of theDataSource to data column theColumnIdentifier of theDataSource
	else
		-- Changement de l'ordre du tri
		if sort order of theSortColumn is ascending then
			set sort order of theSortColumn to descending
		else
			set sort order of theSortColumn to ascending
		end if
	end if
	
	-- Pour redessiner le tableau executer la commande update
	update theObject
	
	set selected rows of theObject to {0} -- Pour enlever le fond bleue 
	
end column clicked ---------------------------------------------------





on should quit theObject --- Exécuté à la fermeture de  l'application -----
	log "should quit"
	stockerAllNotesInPlist() -- Ecriture de la data source "Notes" dans l'entrée "NotesToutes" de la P-list 	
end should quit ---------------------------------------------------












on load_Notes() ----------------------------------------------------------------------------
	-----  Chargement à partir de la p-list "com.legallou.MonLogiciel.plist" ------   	
	log "load_Notes"
	tell user defaults
		set ListeDeToutesLesNotes to contents of default entry "NotesToutes" as list
	end tell
	Creation_DataSource_Notes(ListeDeToutesLesNotes) -- Create & load Data Source
	
end load_Notes ----------------------------------------------------------------------------







on Creation_DataSource_Notes(la_liste) --------- création de la data source et initialisation -----------
	log "Creation_DataSource_Notes"
	-- Nous allons définir une "data source" pour stocker en mémoire RAM les données du tableau --
	-- En premier, nous définissons un pointeur sur l'objet tableau sur lequel nous allons travailler --
	set NotesObject to table view "notesTableView" of scroll view "notesScrollView" of window "Main"
	
	-- Maintenant nous définissons une "data source" associée à ce tableau --
	-- elle sera ajouter au autre data source déjà existante --
	-- On lui donne un nom pour la gestion interne --
	set notesDataSource to make new data source at end of data sources with properties {name:"notesDS"}
	
	-- Création des colonnes de données, incluant l'information de tri pour chaque colonne --
	make new data column at end of data columns of notesDataSource with properties {name:"Name", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Description", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Date", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Prix", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Col5", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Col6", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	
	-- Précisons que nous voulons trier les colonnes
	set sorted of notesDataSource to true -- La "data source" est triée
	
	-- Définition de la colonne de tri initiale --
	set sort column of notesDataSource to data column "Name" of notesDataSource
	
	-- Finallement, relions la "data source" au tableau --
	set data source of NotesObject to notesDataSource -- tableau "notesTableView"
	
	-- Stockage, par remplacement, des données dans la data source --
	append notesDataSource with la_liste
	
end Creation_DataSource_Notes ----------------------------------------------






on stockerAllNotesInPlist() ---- Ecriture de la data source "Notes" dans l'entrée "NotesToutes" de la P-list  
	log "stockerAllNotesInPlist"
	---- Récupérons les données du tableau (Data Source) -----	
	set mesNotes to content of contents of notesDataSource as list -- Les données
	
	tell user defaults
		--  Création une entrée dans de la p-list, si elle n'existe pas elle sera créée 
		-- Si elle existe déjà la commande ne génére pas d'erreur
		make new default entry at end of default entries with properties {name:"NotesToutes", contents:mesNotes}
		
		-- Stockage des données dans la p-list
		set contents of default entry "NotesToutes" to mesNotes
	end tell
	
	return true
	
end stockerAllNotesInPlist -----------------------------------------------






(* ================= For Debug or Initialisation ================== *)



on Notes_Init_Data() ------------- Pour la première exécution ---------------------
	
	----------------------------- Liste initiale pour la démo --------------------------
	set ListeDeDemo to {{"Transmit", "FTP", date "mercredi 6 décembre 2006 0:00:00", 29, 95}, {"CDpedia", "Gestionnaire de CD", date "jeudi 11 octobre 2007 0:00:00", 16}, {"Coda", "Editeur de CSS & HTML", date "vendredi 7 décembre 2007 0:00:00", 69}}
	
	Creation_DataSource_Notes(ListeDeDemo) -- Create & load Data Source
	
	-- Notez pour la date, c'est xCode qui traduit 6/12/2006 en date longue
	-- La frappe initiale est {"Transmit", "FTP", date "6/12/2006", 29, 95}
	
end Notes_Init_Data ----------------------------------------------------------------------

(* ====================================================== *)
